#ifndef BASE_H
#define BASE_H

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#include <math.h>

#define BUFLEN 50000
#define MAX_ENV_LEN 512

#define MAX_TIME 1000
#define FULLDAY  24*60*60

#define MIN(A,B) ((A)<(B) ? (A) : (B))
#define MAX(A,B) ((A)>(B) ? (A) : (B))

#define CRASH { char *ptr=NULL; *ptr=0; }

char *strlwr(char *s);
char *strupr(char *s);

#define SPACES " \t\r\n"

#define FREE(XX) {free(XX);XX=NULL;}

#if !defined(PATH_MAX)
#  define PATH_MAX 512
#endif

void Error(char *fmt, ...);
void Warning(char *fmt, ...);
void Notice(char *fmt, ...);

char*       Trim          ( char *dst, char *src );
int         SimpleCompare ( char *str1, char *str2 );

char *GetTempDir(); 
char *GetHomeDir(char *execpath); 
void DelFile(char *name);
int SyncSystem(char *cmd, int winflag); 
int AsyncSystem(char *cmd);

FILE* MyOpenFile(char *fname, char *mode);
int SimpleCompare(char *str1, char *str2);

void Pad(char *buf, char *src, int N);
char *StrZero(char *buf, int N, int len);
char *DateStr(char *buf, time_t t);
char *TimeStr(char *buf, time_t t);
char *HexTime(char *buf, time_t t);
void ZapDirectory(char *path, int remove, char *ignore);

int ReadSetup(char *path);
int CheckSetup(char *msg);

int ParseLine(char *linebuf, char ***pwords);

#endif

