/* c_error.cpp: error functions for console-mode programs */

#include "base.h"

extern FILE *errfile;

void Error(char *fmt, ...) {
    char buf[1024];
    va_list args;

    va_start(args,fmt);
    sprintf(buf,"ERROR: ");
    vsprintf(buf+strlen(buf),fmt,args);
    va_end(args);
    strcat(buf,"\n");
    if( errfile!=NULL )
      {
      fputs(buf,errfile);
      fclose(errfile);
      }
    fputs(buf,stdout);
    fflush(stdout);
    exit(1);
    }

void Warning(char *fmt, ...) {
    char buf[1024];
    va_list args;

    va_start(args,fmt);
    sprintf(buf,"WARNING: ");
    vsprintf(buf+strlen(buf),fmt,args);
    va_end(args);
    strcat(buf,"\n");
    if( errfile!=NULL )
      {
      fputs(buf,errfile);
      fflush(errfile);
      }
    // else
      {
      fputs(buf,stdout);
      fflush(stdout);
      }
    }

void Notice(char *fmt, ...) {
    char buf[1024];
    va_list args;

    va_start(args,fmt);
    sprintf(buf,"WARNING: ");
    vsprintf(buf+strlen(buf),fmt,args);
    va_end(args);
    strcat(buf,"\n");
    if( errfile!=NULL ) fputs(buf,errfile);
    fputs(buf,stdout);
    fputs("...Press a key to continue...\n",stdout);
    (void)getchar();
    }

char *GetTempDir() 
  {
  char *ptr, *temp = (char *)calloc(MAX_ENV_LEN,sizeof(char));;

  *temp = 0;
  if( (ptr=getenv("TMP"))!=NULL) strncpy(temp,ptr,MAX_ENV_LEN);
  else if( (ptr=getenv("TEMP"))!=NULL ) strncpy(temp,ptr,MAX_ENV_LEN);
  else strcpy(temp,"/tmp");

  return temp;
  }
