#ifndef GLOBALS_H
#define GLOBALS_H

#ifdef __EMX__
#define strcasecmp(s1,s2) stricmp((s1),(s2))
#define strncasecmp(s1,s2,l) strnicmp((s1),(s2),(l))
#endif

#define __COMMA ,

#include "sched.h"

/* Constants */

/* these are used to load different start and finish times from the file */
#define TNORM 0
#define TACTUAL 1
#define TBASE 2

/* the min date that we can support */
#define MINDATE 1		// for the future when we might want to have times befor the start

/* an invalid dayno we can check for to ensure things are assigned values */
#define INVALIDDAYNO (-1)

#ifdef VARIABLE
#  undef VARIABLE
#endif

#ifdef C_FILE
# define VARIABLE(AA,BB,CC) AA BB = CC;
#else
# define VARIABLE(AA,BB,CC) extern AA BB;
#endif

/* Error stream: */
VARIABLE(FILE,         *errfile,          0)

VARIABLE(char,         hexdigit[],        "0123456789ABCDEF")

VARIABLE(time_t,       startTime, 0)

VARIABLE(int,          finishDay, INVALIDDAYNO)

/* Directories: */
VARIABLE(char,         *temp_dir,         NULL)
VARIABLE(char,         *home_dir,         NULL)

/* Our data structures: */
VARIABLE(RESLIST,      *reslist,          NULL)
VARIABLE(TASKLIST,     *tasklist,         NULL)
VARIABLE(RESLIST,      **last_reslist,    &reslist)
VARIABLE(TASKLIST,     **last_tasklist,   &tasklist)
VARIABLE(DAYNAME,      days[MAX_TIME],    {{0 __COMMA NULL}})
VARIABLE(MILESTONELIST, *milestonelist,   NULL)
VARIABLE(MILESTONELIST, **last_mstonelist, &milestonelist)

/* Output files and formatting: */
VARIABLE(char,         *date_format,        NULL)
VARIABLE(char,         *text_report,        NULL)
VARIABLE(char,         *tex_report,         NULL)
VARIABLE(char,         *html_report,         NULL)
VARIABLE(char,         *weekly_tex_report,   NULL)
VARIABLE(char,         *monthly_tex_report,  NULL)
VARIABLE(char,         *slippage_tex_report, NULL)
VARIABLE(char,         *weekly_html_report,   NULL)
VARIABLE(char,         *monthly_html_report,  NULL)
VARIABLE(char,         *slippage_html_report, NULL)
VARIABLE(char,         *weekly_txt_report,   NULL)
VARIABLE(char,         *monthly_txt_report,  NULL)
VARIABLE(char,         *slippage_txt_report, NULL)
VARIABLE(char,         *html_cost_report,    NULL)
VARIABLE(int,          print_task_days,   0)
VARIABLE(char,         *hard_schedule,    NULL)
VARIABLE(char,         *util_graph,       NULL)
VARIABLE(TASKGRAPH,    *task_graphs,      NULL)
VARIABLE(TASKNET,      *network_diagrams, NULL)
VARIABLE(int,          task_notes,        0)
VARIABLE(int,          resource_notes,    0)
VARIABLE(int,          dependencies,      0)
VARIABLE(int,          vacations,         0)
VARIABLE(int,          task_ids,          0)
VARIABLE(int,          milestone_ids,     0)

VARIABLE(int,          Ntasks,            0)
VARIABLE(TASKLIST,     *sorted_tasks,     NULL)

VARIABLE(int,          Nmilestones,       0)
VARIABLE(MILESTONELIST, *sorted_milestones, NULL)

/* Variables used to print a task graph: */
VARIABLE(int,          tg_tasklabel,      36)
VARIABLE(int,          tg_left,           (int)(72*3.5))
VARIABLE(int,          tg_width,          10)
VARIABLE(int,          tg_top,            72*7)
VARIABLE(int,          tg_height,         72/8)
VARIABLE(int,          tg_space,          72/4)
VARIABLE(double,       tg_gray,           0.2)
VARIABLE(double,       tg_lightgray,      0.7)
VARIABLE(double,       tg_white,          1.0)
VARIABLE(char,         *tg_fontname1,     "Helvetica")
VARIABLE(double,       tg_fontsize1,      10.0)
VARIABLE(char,         *tg_fontname2,     "Helvetica")
VARIABLE(double,       tg_fontsize2,      5.0)
VARIABLE(char,         *tg_fontname3,     "Helvetica")
VARIABLE(double,       tg_fontsize3,      14.0)
VARIABLE(int,          tg_textup,         3)
VARIABLE(double,       tg_mlgray,         0.3)
VARIABLE(int,          tg_xborder,        10)
VARIABLE(int,          tg_yborder,        10)
VARIABLE(int,          tg_nodays,         0)
VARIABLE(int,          tg_sortbyresource, 0)
 
VARIABLE(int,          pc_width,          190)
VARIABLE(int,          pc_height,         72)
VARIABLE(int,          pc_space,          72)
VARIABLE(int,          pc_textin,         6)
VARIABLE(int,          pc_textup,         6)
VARIABLE(char,         *pc_fontname1,     "Helvetica")
VARIABLE(double,       pc_fontsize1,      10.0)

VARIABLE(int,          pc_start_ny,       0)
VARIABLE(int,          pc_finish_ny,      0)

/* variables related to costing */
VARIABLE(double,       default_rate,      -1.0)
VARIABLE(ITEM,        *pitems,            NULL)

#endif


