#include "globals.h"

#undef DEBUG

int main(int argc, char **argv)
{
    int i;
    TASKGRAPH *tg;
    TASKNET   *pc;
    char temp_log[BUFLEN];

    temp_dir = GetTempDir();
    home_dir = GetHomeDir(argv[0]);

    strcpy(temp_log, "sched.log");
    errfile = fopen(temp_log, "w");

    if ( argc == 1 )
	LoadFile("workplan.sched");
    else
	for ( i=1; i<argc; ++i )
      {
      if( argv[i][0]=='-' )
        {
        printf("USAGE: %s file1 [file2 file3 ...]\n",argv[0]);
        exit(0);
        }
      else
        LoadFile(argv[i]);
      }

  if( FileIsIllegal() )
    Error("Illegal schedule file(s)!\n");

  #ifdef DEBUG
    PrintFile();
  #endif

  DoScheduling();

  SlippageReport();

  if( text_report!=NULL )
    TextReport(text_report);

  if( weekly_tex_report!=NULL )
    WeeklyReport(weekly_tex_report,TEX_REPORT);
  if( monthly_tex_report!=NULL )
    MonthlyReport(monthly_tex_report,TEX_REPORT);

  if( weekly_html_report!=NULL )
    WeeklyReport(weekly_html_report,HTML_REPORT);
  if( monthly_html_report!=NULL )
    MonthlyReport(monthly_html_report,HTML_REPORT);

  if( weekly_txt_report!=NULL )
    WeeklyReport(weekly_txt_report,TXT_REPORT);
  if( monthly_txt_report!=NULL )
    MonthlyReport(monthly_txt_report,TXT_REPORT);

  if( tex_report!=NULL )
    TexReport(tex_report);

  if( html_report!=NULL )
    HTMLReport(html_report);

  if( hard_schedule!=NULL )
    HardSchedule(hard_schedule);

  if( util_graph!=NULL )
    UtilGraph(util_graph);

  for( tg=task_graphs; tg!=NULL; tg=tg->next )
    TaskGraph(tg->start, tg->finish, tg->filename);

    for ( pc = network_diagrams ; pc != NULL; pc = pc->next )
	NetworkDiagram(pc->start, pc->finish, pc->filename);

    if ( html_cost_report != NULL )
	CostReport(html_cost_report, HTML_REPORT);

    fclose(errfile);
    return 0;
}
