#include "globals.h"

char *GetHomeDir(char *execpath) 
  {
  char *ptr, *home = (char *)calloc(MAX_ENV_LEN,sizeof(char));

  if( execpath==NULL || *execpath==0 ) 
    {
    strcpy(home,"./");
    return home;
    }

  strcpy(home,execpath);
  for( ptr=home+strlen(home)-1; ptr>=home; --ptr ) 
    {
    if( *ptr=='\\' || *ptr=='/' || *ptr==':' ) 
      {
      *(ptr+1) = 0;
      break;
      }
    }

  if ( !strcmp(home, execpath) ) *home=0;

  return home;
  }

void DelFile(char *name) 
  {
  char *temp;
  if( ( temp=getenv("PSYNCH_DEBUG"))!=0 ) 
    return;
  else 
    {
    FILE *tmp;
    long flen;
    tmp = fopen(name,"rb");
    if( tmp!=NULL ) 
      {
      (void)fseek(tmp,0L,SEEK_END);
      flen = ftell(tmp);
      fclose(tmp);
      tmp = fopen(name,"wb");
      if( tmp!=NULL ) 
        {
        while( (flen--)>0 ) fputc('-',tmp);
        fclose(tmp);
        }
      }
    unlink(name);
    }
  }

int AsyncSystem(char *cmd)
  {
  char mycmd[BUFLEN];
  strcpy(mycmd,cmd);
  strcat(mycmd,"&");
  return system(mycmd);
  }

char *strlwr(char *s)
  {
  char *p;
  if( s!=NULL )
    for(p=s; *p!=0;++p )
      if( isupper((int)(*p)) )
        *p = tolower((int)(*p));
  return s;
  }

char *strupr(char *s)
  {
  char *p;
  if( s!=NULL )
    for(p=s; *p!=0;++p )
      if( islower((int)(*p)) )
        *p = toupper((int)(*p));
  return s;
  }


FILE *MyOpenFile(char *fname, char *mode) 
  {
  FILE *f=NULL;

  if ( (f=fopen(fname, mode)) != NULL )
    return f;

  if ( home_dir != NULL ) 
    {   
    char tmpname[MAX_ENV_LEN*2];
    strcpy(tmpname, home_dir);
    strcat(tmpname, fname);
    f = fopen(tmpname, mode);
    }

  return f;
  }

/* Returns 1 if matches, 0 if doesn't */
int do_match(char *str, char *regexp, int case_sig)
{
    char *p;

    for ( p = regexp ; *p && *str ;  )
    {
	switch ( *p )
	{
	    case '?':
		str++;
		p++;
		break;
  
	    case '*':
		/* Look for a character matching 
	           the one after the '*' */
		p++;
		if (!*p)
		    return 1; /* Automatic match */
  
		while(*str)
		{
		    while ( *str && (case_sig ? (*p != *str) : (toupper(*p)!=toupper(*str))))
			str++;
		    if (do_match(str, p, case_sig))
			return 1;
		    if (!*str)
			return 0;
		    else
			str++;
		}
  
		return 0;
  
	    default:
		if (case_sig)
		{
		    if (*str != *p)
			return 0;
		}
		else
		{
		    if (toupper(*str) != toupper(*p))
			return 0;
		}
  
		str++, p++;
		break;
	}
    }

    if ( !*p && !*str )
	return 1;

    if ( ( !*p && str[0] == '.' ) && ( str[1] == 0 ) )
	return(1);
  
    if (!*str && *p == '?')
    {
	while (*p == '?')
	    p++;
	return !*p;
    }

    if (!*str && (*p == '*' && p[1] == '\0'))
	return 1;

    return 0;
}

void Pad(char *buf, char *src, int N)
  {
  int i;
  strncpy(buf,src,N);
  buf[N]=0;
  for( i=strlen(buf); i<N; ++i )
    buf[i] = ' ';
  buf[N] = 0;
  }

char *StrZero(char *buf, int N, int len)
  {
  int i, j, place;
  for( i=1, place=1; i<len; ++i )
    place *= 10;
  for( i=0; i<len; ++i )
    {
    j = (N / place) % 10;
    N -= place * j;
    place /= 10;
    buf[i] = hexdigit[j];
    }
  buf[len] = 0;
  return buf;
  }

char *DateStr(char *buf, time_t t)
  {
  char year[10], month[10], day[10];
  struct tm *tmp;

  if( t==0 )
    strcpy(buf,"00000000");
  else
    {
    tmp = localtime(&t);
    sprintf(buf,"%s%s%s",
                StrZero(year,tmp->tm_year+1900,4),
                StrZero(month,tmp->tm_mon+1,2),
                StrZero(day,tmp->tm_mday,2));
    }

  return buf;
  }

char *TimeStr(char *buf, time_t t)
  {
  char hour[10], minute[10];
  struct tm *tmp;

  tmp = localtime(&t);
  sprintf(buf,"%s:%s",
              StrZero(hour,tmp->tm_hour,2),
              StrZero(minute,tmp->tm_min,2));

  return buf;
  }

char *HexTime(char *buf, time_t t)
  {
  sprintf(buf,"%08lx",(long)t);
  return buf;
  }

void ZapDirectory(char *path, int remove, char *ignore)
  {
  DIR *d, *test;
  struct dirent *de;
  d = opendir(path);
  if( d==NULL )
    return;
  while( (de=readdir(d))!=NULL )
    {
    if( ignore!=NULL && strstr(de->d_name,ignore)!=NULL )
      continue;
    test = opendir(de->d_name);
    if( test!=NULL )
      closedir(test);
    else
      {
      char buf[PATH_MAX];
      strcpy(buf,path);
      if( buf[strlen(buf)-1]!='/' )
        strcat(buf,"/");
      strcat(buf,de->d_name);
      unlink(buf);
      }
    }

  if( remove )
    rmdir(path);
  }

char *FindEnd(char *str)
  {
  char *end;
  end = str+strlen(str)-1;
  if( end<str ) end = str;
  while( *end==' ' && end>str )
    --end;
  return end;
  }

int SimpleCompare(char *str1, char *str2)
  {
  char *end1, *end2;
  int s1, s2;

  end1 = FindEnd(str1);
  end2 = FindEnd(str2);

  if( end1-str1 != end2-str2 )
    return -2;

  for( ; str1<=end1 && str2<=end2; ++str1, ++str2 )
    {
/*
    s1 = toupper(*str1);
    s2 = toupper(*str2);
*/
    s1 = *str1;
    s2 = *str2;

    if( s1 < s2 )
      return -1;
    if( s1 > s2 )
      return 1;
    }

  return 0;
  }

char *Trim(char *dst, char *src)
  {
  char *d, *s;
  for( s=src, d=dst; *s!=0; ++s, ++d )
    {
    if( *s==0 )
      {
      *d = 0;
      break;
      }
    else
      *d = *s;
    }

  for( --d; d>dst; --d )
    {
    if( *d==' ' )
      *d = 0;
    else
      {
      *(++d) = 0;
      break;
      }
    }

  if( d==dst )
    *d = 0;

  return dst;
  }
